
#property copyright "Copyright  2009."
#property link      "http://www.iforex-indicators.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Black
#property indicator_color2 Black
//----
extern bool Show_Alert = true;
extern bool Display_Bearish_Engulfing = true;
extern bool Display_Three_Outside_Down = false;
extern bool Display_Three_Inside_Down = false;
extern bool Display_Dark_Cloud_Cover = false;
extern bool Display_Three_Black_Crows = false;
extern bool Display_Bullish_Engulfing = true;
extern bool Display_Three_Outside_Up = false;
extern bool Display_Three_Inside_Up = false;
extern bool Display_Piercing_Line = false;
extern bool Display_Three_White_Soldiers = false;
extern bool Display_Stars = false;
extern bool Display_Harami = false;
extern bool Inside_Bar_Bull = false;
extern bool Inside_Bar_Bear = false;
//---- buffers
double upArrow[];
double downArrow[];
string PatternText[5000];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
  {
   SetIndexStyle(0, DRAW_ARROW, 0, 1);
   SetIndexArrow(0, 242);
   SetIndexBuffer(0, downArrow);      
//----
   SetIndexStyle(1, DRAW_ARROW, 0, 1);
   SetIndexArrow(1, 241);
   SetIndexBuffer(1, upArrow);
      
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
  {
   ObjectsDeleteAll(0, OBJ_TEXT);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double Range, AvgRange;
   int counter, setalert;
   static datetime prevtime = 0;
   int shift;
   int shift1;
   int shift2;
   int shift3;
   int shift4;
   int shift5;
   int shift6;
   int shift7; 
   string pattern, period;
   int setPattern = 0;
   int alert = 0;
   int arrowShift;
   int textShift;
   double O, O1, O2, C, C1, C2, L, L1, L2, L3, L4, L5, L6, H, H1, H2, H3, H4, H5, H6;     
//----
   if(prevtime == Time[0]) 
     {
       return(0);
     }
   prevtime = Time[0];   
//----
   switch(Period()) 
     {
       case 1:     period = "M1";  break;
       case 5:     period = "M5";  break;
       case 15:    period = "M15"; break;
       case 30:    period = "M30"; break;      
       case 60:    period = "H1";  break;
       case 240:   period = "H4";  break;
       case 1440:  period = "D1";  break;
       case 10080: period = "W1";  break;
       case 43200: period = "MN";  break;
     }
//----
   for(int j = 0; j < Bars; j++) 
     { 
       PatternText[j] = "pattern-" + j;
     }
//----
   for(shift = 0; shift < Bars; shift++) 
     {
       setalert = 0;
       counter = shift;
       Range = 0;
       AvgRange = 0;
       for(counter = shift; counter <= shift + 13; counter++) 
         {
           AvgRange = AvgRange + MathAbs(High[counter] - Low[counter]);
         }
       Range = AvgRange / 10;
       shift1 = shift + 1;
       shift2 = shift + 2;
       shift3 = shift + 3;      
       shift4 = shift + 4; 
       shift5 = shift + 5; 
       shift6 = shift + 6; 
       shift7 = shift + 7; 
       O = Open[shift1];
       O1 = Open[shift2];
       O2 = Open[shift3];
       H = High[shift1];
       H1 = High[shift2];
       H2 = High[shift3];
       H3 = High[shift3+1];
       H4 = High[shift3+2];
       H5 = High[shift3+3];
       H6 = High[shift3+4];
       L = Low[shift1];
       L1 = Low[shift2];
       L2 = Low[shift3];
       L3 = Low[shift3+1];
       L4 = Low[shift3+2];
       L5 = Low[shift3+3];
       L6 = Low[shift3+4];
       C = Close[shift1];
       C1 = Close[shift2];
       C2 = Close[shift3];         
       // Bearish patterns  
       // Bearish Engulfing pattern
       if((C1 > O1) && (O > C) && (O1 >= C) && (H > H1) && (L < L1) && ((O - C) > (C1 - O1)) && ((H - L) > (H1 - L1) && (H2 - L2) && (H3 - L3) && (H4 - L4) && (H5 - L5) && (H6 - L6))) 
         {
           if(Display_Bearish_Engulfing == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Bearish Engulfing pattern", 10, 
                             "Arial", Black);
               downArrow[shift1] = High[shift1] + Range*0.5;
             }
           if(setalert == 0 && Show_Alert == true) 
             {
               pattern = "Bearish Engulfing pattern";
               setalert = 1;
             }
         }
       // Three Outside Down pattern
       if((C2 > O2) && (O1 > C1) && (O1 >= C2) && (O2 >= C1) && ((O1 - C1) > (C2 - O2)) && 
          (O > C) && (C < C1)) 
         {
           if(Display_Three_Outside_Down == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Three Outside Down pattern", 10, 
                             "Arial", Black);
               upArrow[shift1] = Low[shift1] - Range*0.5;
             }
           if(setalert == 0 && Show_Alert == true) 
             {
               pattern = "Three Outside Down pattern";
               setalert = 1;
             }
         }
       // Dark Cloud Cover pattern
       if((C1 > O1) && (((C1 + O1) / 2) > C) && (O > C) && (O > C1) && (C > O1) && 
          ((O - C) / (0.001 + (H - L)) > 0.6)) 
         {
           if(Display_Dark_Cloud_Cover == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Dark Cloud Cover pattern", 10, 
                             "Arial", Black);
               downArrow[shift1] = High[shift1] + Range*0.5;
             }
           //----
           if(setalert == 0 && Show_Alert == true) 
             {
               pattern = "Dark Cloud Cover pattern";
               setalert = 1;
             }
         }     
       // Evening Doji Star pattern
       if((C2 > O2) && ((C2 - O2) / (0.001 + H2 - L2) > 0.6) && (C2 < O1) && (C1 > O1) && 
          ((H1-L1) > (3*(C1 - O1))) && (O > C) && (O < O1)) 
         {
           if(Display_Stars == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Evening Doji Star pattern", 10, 
                             "Arial", Black);
               downArrow[shift1] = High[shift1] + Range*0.5;
             }
           //----
           if(setalert == 0 && Show_Alert == true) 
             {
               pattern = "Evening Doji Star pattern";
               setalert = 1;
             }
         }     
            // Inside Bar Bear Pattern
       if((C1 < O1) && (C > O) && (C > C1) && (H < H1) && (L > L1)) 
         {
           if(Inside_Bar_Bear == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Inside Bar Bear", 10, 
                             "Arial", Black);
               downArrow[shift1] = High[shift1] + Range*0.5;
             }
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Inside Bar Bear";
               setalert = 1;
             }
         }      
       // Bearish Harami pattern
       if((C1 > O1) && (O > C) && (O <= C1) && (O1 <= C) && ((O - C) < (C1 - O1))) 
         {
           if(Display_Harami == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Bearish Harami pattern", 10, 
                             "Arial", Black);
               downArrow[shift1] = High[shift1] + Range*0.5;
             }
           if(shift == 0 && Show_Alert == true) 
             {
               pattern="Bearish Harami pattern";
               setalert = 1;
             }
         }
       // Three Inside Down pattern
       if((C2 > O2) && (O1 > C1) && (O1 <= C2) && (O2 <= C1) && ((O1 - C1) < (C2 - O2)) && 
          (O > C) && (C < C1) && (O < O1)) 
         {
           if(Display_Three_Inside_Down == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Three Inside Down pattern", 10, 
                             "Arial", Black);
               downArrow[shift1] = High[shift1] + Range*0.5;
             }
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Three Inside Down pattern";
               setalert = 1;
             }
         }   
       // Three Black Crows pattern
       if((O > C*1.01) && (O1 > C1*1.01) && (O2 > C2*1.01) && (C < C1) && (C1 < C2) && 
          (O > C1) && (O < O1) && (O1 > C2) && (O1 < O2) && (((C - L) / (H - L)) < 0.2) && 
          (((C1 - L1) / (H1 - L1)) < 0.2) && (((C2 - L2) / (H2 - L2)) < 0.2))
         {
           if(Display_Three_Black_Crows == true)
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Three Black Crows pattern", 10, 
                             "Arial", Black);
               downArrow[shift1] = High[shift1] + Range*0.5;
             }
           //----
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Three Black Crows pattern";
               setalert = 1;
             }
         }
       //Evening Star Pattern
       if((C2 > O2) && ((C2 - O2) / (0.001 + H2 - L2) > 0.6) && (C2 < O1) && (C1 > O1) && 
          ((H1 - L1) > (3*(C1 - O1))) && (O > C) && (O < O1)) 
         {
           if(Display_Stars == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Evening Star Pattern", 10, "Arial", Black);
               downArrow[shift1] = High[shift1] + Range*0.5;
             }
           //----
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Evening Star Pattern";
               setalert = 1;
             }
         }
     
       // Bullish Patterns
       // Bullish Engulfing pattern
       if((O1 > C1) && (C > O) && (C1 >= O) && (H > H1) && (L < L1) && ((C - O) > (O1 - C1)) && ((H-L)>(H1-L1)&&(H2-L2)&&(H3-L3)&&(H4-L4)&&(H5-L5)&&(H6-L6))) 
         {
           if(Display_Bullish_Engulfing) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Bullish Engulfing pattern", 10, 
                             "Arial", Black);
               upArrow[shift1] = Low[shift1] - Range*0.5;
             }
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Bullish Engulfing pattern";
               setalert = 1;
             }
         }
       // Three Outside Up pattern
       if((O2 > C2) && (C1 > O1) && (C1 >= O2) && (C2 >= O1) && ((C1 - O1) > (O2 - C2)) && 
          (C > O) && (C > C1)) 
         {
           if(Display_Three_Outside_Up == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Three Outside Up pattern", 10, 
                             "Arial", Black);
               upArrow[shift1] = Low[shift1] - Range*0.5;
             }
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Three Outside Up pattern";
               setalert = 1;
             }
         }
       // Bullish Harami pattern
       if((O1 > C1) && (C > O) && (C <= O1) && (C1 <= O) && ((C - O) < (O1 - C1))) 
         {
           if(Display_Harami == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Bullish Harami pattern", 10, 
                             "Arial", Black);
               upArrow[shift1] = Low[shift1] - Range*0.5;
             }
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Bullish Harami pattern";
               setalert = 1;
             } 
         }
       // Three Inside Up pattern
       if((O2 > C2) && (C1 > O1) && (C1 <= O2) && (C2 <= O1) && ((C1 - O1) < (O2 - C2)) && 
          (C > O) && (C > C1) && (O > O1)) 
         {
           if(Display_Three_Inside_Up == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Three Inside Up pattern", 10, 
                             "Arial", Black);
               upArrow[shift1] = Low[shift1] - Range*0.5;
             }
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Three Inside Up pattern";
               setalert = 1;
             }
         }      
           // Inside Bar Bull Pattern
       if((C1 > O1) && (C < O) && (C < C1) && (H < H1) && (L > L1)) 
         {
           if(Inside_Bar_Bull == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Inside Bar Bull", 10, 
                             "Arial", Black);
               upArrow[shift1] = Low[shift1] - Range*0.5;
             }
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Inside Bar Bull";
               setalert = 1;
             }
         }      
       // Piercing Line pattern
       if((C1 < O1) && (((O1 + C1) / 2) < C) && (O < C) && (O < C1) && (C < O1) && 
          ((C - O) / (0.001 + (H - L)) > 0.6)) 
         {
           if(Display_Piercing_Line == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Piercing Line pattern", 10, 
                             "Arial", Black);
               upArrow[shift1] = Low[shift1] - Range*0.5;
             }
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Piercing Line pattern";
               setalert = 1;
             }
         }      
       // Three White Soldiers pattern
       if((C > O*1.01) && (C1 > O1*1.01) && (C2 > O2*1.01) && (C > C1) && (C1 > C2) && 
          (O < C1) && (O > O1) && (O1 < C2) && (O1 > O2) && (((H - C) / (H - L)) < 0.2) && 
          (((H1 - C1) / (H1 - L1)) < 0.2) && (((H2 - C2) / (H2 - L2)) < 0.2)) 
         {
           if(Display_Three_White_Soldiers == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Three White Soldiers pattern", 10, 
                             "Arial", Black);
               upArrow[shift1] = Low[shift1] - Range*0.5;
             }
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Three White Soldiers pattern";
               setalert = 1;
             }
         }     
       // Morning Doji Star
       if((O2 > C2) && ((O2 - C2) / (0.001 + H2 - L2) > 0.6) && (C2 > O1) && (O1 > C1) && 
          ((H1 - L1) > (3*(C1 - O1))) && (C > O) && (O > O1)) 
         {
           if(Display_Stars == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Morning Doji Star", 10, 
                             "Arial", Black);
               upArrow[shift1] = Low[shift1] - Range*0.5;
             }
           if(shift == 0 && Show_Alert == true) 
             {
               pattern = "Morning Doji Star";
               setalert = 1;
             }
         }
       if(setalert == 1 && shift == 0) 
         {
           Alert(Symbol(), " ", period, " ", pattern);
           setalert = 0;
         }
     } // End of for loop
   return(0);
  }
//+------------------------------------------------------------------+